/**
 * a)Umseitig ist die Methode fragezeichenFunc sowie die rekursive Methode fragezeichenRec bis auf mit grauen Rechecken gekennzeichnete Fehler definiert.
 * Ein Aufruf der korrekten Methode fragezeichenFunc wie in der Methode main angegeben schreibt folgendes Ergebnis am Bildschirm.
 * <p/>
 * Rekursionstiefe 0: Aufruf von fragezeichenRec mit Parameter index_n = 6
 * Rekursionstiefe 1: Aufruf von fragezeichenRec mit Parameter index_n = 5
 * Rekursionstiefe 2: Aufruf von fragezeichenRec mit Parameter index_n = 4
 * Rekursionstiefe 3: Aufruf von fragezeichenRec mit Parameter index_n = 3
 * Rekursionstiefe 4: Aufruf von fragezeichenRec mit Parameter index_n = 2
 * Rekursionstiefe 5: Aufruf von fragezeichenRec mit Parameter index_n = 1
 * Rekursionstiefe 6: Aufruf von fragezeichenRec mit Parameter index_n = 0
 * <p/>
 * FragezeichenRec in Rekursionstiefe 6 gibt den Wert 4 zurück.
 * FragezeichenRec in Rekursionstiefe 5 gibt den Wert 4 zurück.
 * FragezeichenRec in Rekursionstiefe 4 gibt den Wert 16 zurück.
 * FragezeichenRec in Rekursionstiefe 3 gibt den Wert 32 zurück.
 * FragezeichenRec in Rekursionstiefe 2 gibt den Wert 32 zurück.
 * FragezeichenRec in Rekursionstiefe 1 gibt den Wert 32 zurück.
 * FragezeichenRec in Rekursionstiefe 0 gibt den Wert 64 zurück.
 * <p/>
 * Bessern Sie die grauen Rechtecke aus. Welche Funktionalität erfüllt besonders die Methode fragezeichenRec und welche Auswirkungen hat sie auf die in main definierten Variablen?
 * <p/>
 * Hinweis: Fassen Sie bei Ihrer Betrachtung Ausgabezeilen mit gleicher Rekursionstiefe zusammen, also z.B.
 * Rekursionstiefe 4: Aufruf von fragezeichenRec mit Parameter index_n = 2
 * und
 * FragezeichenRec in Rekursionstiefe 4 gibt den Wert 16 zurück.
 * <p/>
 * Beginnen Sie Ihre Analyse bei der tiefsten Rekursionstiefe von 5.
 * <p/>
 * b)Schreiben Sie eine statische Methode namens iter welche die gleiche Funktionalität wie fragezeichenFunc realisiert. iter soll allerdings ohne Verwendung einer Rekursion programmiert werden.
 */

public class AdHoc1 {

    public static int fragezeichenFunc(int[] arr_local1, int index_n1) {
        return (fragezeichenRec(arr_local1, index_n1, 0));
    }

    public static int fragezeichenRec(int[] arr_local, int index_n, int depth) {
        System.out.println("Rekursionstiefe " + depth + ": Aufruf von fragezeichenRec mit Parameter index_n = " + index_n);

        int result;

        if (index_n == 0) {//Abbruchbedingung (Stichwort Fundiertheit)
            result = arr_local[arr_local.length - 3/*TODO: Den Ausdruck in den Klammern darf man ändern*/];
        } else { // 1) Reduktion auf ein kleineres Problem
            // 2) Rekursiver Aufruf mit dem kleineren Problem (Stichwort Fortschritt)
            // 3) Heranziehen des Ergebnisses vom rekursiven Aufruf und Zusammenbauen der Lösung
            result = fragezeichenRec(arr_local, depth * depth, index_n / 8) * arr_local[10]; /* TODO: es dürfen nur die Punkte verändert werden: result=fragezeichenRec(arr_local,..,..)*(..);*/
            arr_local[index_n] = result;
        }
        if (index_n == 0) {
            System.out.println();
        }
        System.out.println("fragezeichenRec in Rekursionstiefe " + depth + "gibt den Wert " + result + " zurück");

        return result;
    }

    public static int iter(int[] arr_local1, int index_n1) {
        //TODO: was in der Angabe steht
    return 0;}

    public static void main(String[] args) {
        int arr[] = {4, 1, 4, 2, 1, 1, 2};
        System.out.println(arr.length);// --> 7

        System.out.println(fragezeichenFunc(arr, arr.length - 1));

        for (int wert : arr) {
            System.out.println(wert);
        }

        System.out.println("-------------------------------------------");

        int arr1[] = {4, 1, 4, 2, 1, 1, 2};
        System.out.println(iter(arr1, arr1.length - 1));
        for (int wert : arr1) {
            System.out.println(wert);
        }
    }
}

