/**
 *  Nikodemus besucht die Lehrveranstaltung Programmkonstruktion. Um über die wichtigsten Begriffe aus dieser LVA bescheid zu wissen, möchte er sich ein
 *  computerbasiertes Lexikon anlegen. Dieses soll aus einer Sammlung von Bäumen bestehen. Als Vorstufe zu diesem Lexikon hat Nikodemus einen Baum wie folgt
 *  entworfen.
 *
 *                                  'D'
 *                                  ""
 *                              |               |
 *                              'e'             'a'
 *                              ""               ""
 *                            |        |                |
 *                            'k'       'q'             't'
 *                            "laff"     "ue"            ""
 *                                                      |
 *                                                      'e'
 *                                                      ""
 *                                                  |           |
 *                                                  'n'         'i'
 *                                                  "typ"       ""
 *
 *  Die Wörter aus dem Lexikon sollen genau den Blättern des Baumes entsprechen und mitteld der Knoteninhalte auf dem direkten Weg von der Wurzel zum jeweiligen
 *  Blatt gebildet werden. In obigem Baum sind auf diese Weise von links nach rechts die Wörter
 *
 *                      Deklaration, Deque, Datentyp und Datei
 *
 *  enthalten.
 *
 *
 *  a) Nikodemus hofft mit unsortierten Binärbäumen auszukommen. Definieren Sie eine Klassen die jeden Knoten eines solchen Binärbaums abbildet
 *    (eine Objektvariable für ein Zeichen und eine für eine Zeichenkette) samt zugehörigem sinnvollen Konstruktor.
 *
 *  b) Erstellen Sie obigen Baum mithilfe von Objekten der in Punkt a definierten Klasse in der main-Methode. Dieser Konstruktor kann händisch oder
 *     mithilfegeeigneter Methoden erfolgen (und muss keinerlei problemspezifische Automatismen enthalten)
 *
 *     Achtung: Der Buchstabe "e"kommt im Baum doppelt vor.
 *
 *  c) Um die Richtigkeit Ihres in Punkt b erstellten Baumes zu überprüfen, schreiben Die ein Programmstück  (im main oder als eigene Methode),
 *     welches für einen derartigen "Wortbaum" die Erzeugung eines zufälligen gespeicherten Wortes erlaubt. Dabei soll bei jedem Knoten mit zwei
 *     Nachfolger nach unten fortgesetzt werden.
 *
 *                     |
 *                     v
 *     Chance 50% <-- 'x' --> Chance 50%
 *                     ""
 *
 *     Geben Sie 10 solcher zufälliger Wörter des Baumes aus.
 *
 *     Hinweis: Der Aufruf (int) (Math.random()*2.) liefer Ihnen dazu die Werte 0 und 1 mit der verlangten Chance von je 50%
 *
 *
 */
public class AdHoc2 {
}
